<?php

class DIWG_Divi_Weather extends ET_Builder_Module {

	public $slug       = 'diwg_divi_weather';
	public $vb_support = 'on';

	protected $module_credits = array(
		'module_uri' => 'https://diviweather.com',
		'author'     => 'WP Creator\'s Club',
		'author_uri' => 'https://wpcreatorsclub.com',
	);

	public function init() {
		$this->name = esc_html__( 'Weather', 'diwg-divi-weather-gtm' );
	}

	public function get_settings_modal_toggles() {
		return [
			'general'  => [
				'toggles' => [
					'main_content'	=> esc_html__( 'General Settings', 'diwg-divi-weather-gtm' ),
					'location'      => esc_html__( 'Location', 'diwg-divi-weather-gtm' ),
					'component'     => esc_html__( 'Components', 'diwg-divi-weather-gtm' ),
				],
			],
			'advanced'	=> [
				'toggles'	=> [
					'current_design'	=> esc_html__( 'Current Weather', 'diwg-divi-weather-gtm' ),
					'forecast_design' => esc_html__( 'Forecasted Weather', 'diwg-divi-weather-gtm' ),
				],
			],
		];
	}

	public function get_custom_css_fields_config() {
		return array(
			'current_weather' => array(
				'label'    => esc_html__( 'Current Weather', 'diwg-divi-weather-gtm' ),
				'selector' => '%%order_class%% .et_pb_weather__current',
			),
			'current_weather__before' => array(
				'label'    => esc_html__( 'Current Weather::before', 'diwg-divi-weather-gtm' ),
				'selector' => '%%order_class%% .et_pb_weather__current::before',
			),
			'current_weather__after' => array(
				'label'    => esc_html__( 'Current Weather::after', 'diwg-divi-weather-gtm' ),
				'selector' => '%%order_class%% .et_pb_weather__current::after',
			),
			'additional_data' => array(
				'label'    => esc_html__( 'Current Weather Additional Data Group', 'diwg-divi-weather-gtm' ),
				'selector' => '%%order_class%% .et_pb_weather__current_additional',
			),
			'forecast_list' => array(
				'label'    => esc_html__( 'Forecast List', 'diwg-divi-weather-gtm' ),
				'selector' => '%%order_class%% ul.et_pb_weather__forecast',
			),
			'forecast_list__before' => array(
				'label'    => esc_html__( 'Forecast List::before', 'diwg-divi-weather-gtm' ),
				'selector' => '%%order_class%% .et_pb_weather__forecast::before',
			),
			'forecast_list__after' => array(
				'label'    => esc_html__( 'Forecast List::after', 'diwg-divi-weather-gtm' ),
				'selector' => '%%order_class%% .et_pb_weather__forecast::after',
			),
			'forecast_list_item' => array(
				'label'    => esc_html__( 'Forecast List Items', 'diwg-divi-weather-gtm' ),
				'selector' => '%%order_class%% li.et_pb_weather__forecast_item',
			),
			'forecast_list_item_date' => array(
				'label'    => esc_html__( 'Forecast Item Date', 'diwg-divi-weather-gtm' ),
				'selector' => '%%order_class%% li.et_pb_weather__forecast_item .et_pb_weather__forecast_date',
			),
			'forecast_list_item_desc' => array(
				'label'    => esc_html__( 'Forecast Item Description', 'diwg-divi-weather-gtm' ),
				'selector' => '%%order_class%% li.et_pb_weather__forecast_item .et_pb_weather__forecast_desc',
			),
			'forecast_list_item_icon' => array(
				'label'    => esc_html__( 'Forecast Item Icon', 'diwg-divi-weather-gtm' ),
				'selector' => '%%order_class%% li.et_pb_weather__forecast_item .et_pb_weather__icon',
			),
			'forecast_list_item_temp' => array(
				'label'    => esc_html__( 'Forecast Item Temp', 'diwg-divi-weather-gtm' ),
				'selector' => '%%order_class%% li.et_pb_weather__forecast_item .et_pb_weather__forecast_temp',
			),
		);
	}

  public function get_advanced_fields_config() {
    return [
			'fonts' => [
				'current_description' => [
					'css' => [
						'main' => "%%order_class%% .et_pb_weather__current_description",
					],
					'font_size' => [
						'default' => '17px',
					],
					'line_height' => [
						'default' => '1.3em',
					],
					'label' => esc_html__( 'Current Description', 'diwg-divi-weather-gtm' ),
				],
				'current_temperature' => [
					'css' => [
						'main' => "%%order_class%% .et_pb_weather__current_temp",
					],
					'font_size' => [
						'default' => '17px',
					],
					'line_height' => [
						'default' => '1.3em',
					],
					'label' => esc_html__( 'Current Temp', 'diwg-divi-weather-gtm' ),
				],
				'current_min_max' => [
					'css' => [
						'main' => "%%order_class%% .et_pb_weather__current_min_max",
					],
					'font_size' => [
						'default' => '17px',
					],
					'line_height' => [
						'default' => '1.3em',
					],
					'label' => esc_html__( 'Current Min/Tax Temp', 'diwg-divi-weather-gtm' ),
				],
				'current_humidity' => [
					'css' => [
						'main' => "%%order_class%% .et_pb_weather__current_humidity",
					],
					'font_size' => [
						'default' => '17px',
					],
					'line_height' => [
						'default' => '1.3em',
					],
					'label' => esc_html__( 'Current Humidity', 'diwg-divi-weather-gtm' ),
				],
				'current_pressure' => [
					'css' => [
						'main' => "%%order_class%% .et_pb_weather__current_pressure",
					],
					'font_size' => [
						'default' => '17px',
					],
					'line_height' => [
						'default' => '1.3em',
					],
					'label' => esc_html__( 'Current Pressure', 'diwg-divi-weather-gtm' ),
				],
				'current_wind' => [
					'css' => [
						'main' => "%%order_class%% .et_pb_weather__current_wind",
					],
					'font_size' => [
						'default' => '17px',
					],
					'line_height' => [
						'default' => '1.3em',
					],
					'label' => esc_html__( 'Current Wind', 'diwg-divi-weather-gtm' ),
				],
				'forecast_date' => [
					'css' => [
						'main' => "%%order_class%% .et_pb_weather__forecast_date",
					],
					'font_size' => [
						'default' => '17px',
					],
					'line_height' => [
						'default' => '1.3em',
					],
					'label' => esc_html__( 'Forecast Date', 'diwg-divi-weather-gtm' ),
				],
				'forecast_description' => [
					'css' => [
						'main' => "%%order_class%% .et_pb_weather__forecast_desc",
					],
					'font_size' => [
						'default' => '17px',
					],
					'line_height' => [
						'default' => '1.3em',
					],
					'label' => esc_html__( 'Forecast Description', 'diwg-divi-weather-gtm' ),
				],
				'forecast_temperature' => [
					'css' => [
						'main' => "%%order_class%% .et_pb_weather__forecast_temp",
					],
					'font_size' => [
						'default' => '17px',
					],
					'line_height' => [
						'default' => '1.3em',
					],
					'label' => esc_html__( 'Forecast Temp', 'diwg-divi-weather-gtm' ),
				],
			],
			'filters' => false,
			'text' => false,
		];
	}

	public function get_fields() {

		$et_accent_color = et_builder_accent_color();

		$fields = [
			'unit' => [
				'label'           => esc_html__( 'Units', 'diwg-divi-weather-gtm' ),
				'type'            => 'select',
				'option_category' => 'basic_option',
				'options'        	=> [
					'metric'	 => esc_html__( 'Metric', 'diwg-divi-weather-gtm' ),
					'imperial' => esc_html__( 'Imperial', 'diwg-divi-weather-gtm' ),
				],
				'default'					=> 'imperial',
				'description'     => esc_html__( 'Metric for Celcius, Imperial for Farenheit', 'diwg-divi-weather-gtm' ),
				'toggle_slug'     => 'main_content',
			],
			'layout_current' => [
				'label'           => esc_html( 'Layout (Current Weather)', 'diwg-divi-weather-gtm' ),
				'option_category' => 'basic_option',
				'type'            => 'select',
				'options' => [
					'stacked'    => esc_html__( 'Stacked', 'diwg-divi-weather-gtm' ),
					'compact'    => esc_html__( 'Compact', 'diwg-divi-weather-gtm' ),
				],
				'default'     => 'compact',
				'tab_slug'    => 'advanced',
				'toggle_slug' => 'layout',
				'show_if'         => [
					'show_weather_current' => 'on',
				],
			],
			'layout_forecast' => [
				'label'           => esc_html( 'Layout (Forecast)', 'diwg-divi-weather-gtm' ),
				'option_category' => 'basic_option',
				'type'            => 'select',
				'options' => [
					'list' => esc_html__( 'Vertical List', 'diwg-divi-weather-gtm' ),
					'grid' => esc_html__( 'Grid', 'diwg-divi-weather-gtm' ),
				],
				'default'     => 'list',
				'tab_slug'    => 'advanced',
				'toggle_slug' => 'layout',
				'show_if'         => [
					'show_weather_forecast' => 'on',
				],
			],
			'grid_columns'  => [
				'label'            => esc_html__( 'Grid Columns', 'diwg-divi-weather-gtm' ),
				'option_category'  => 'basic_option',
				'type'             => 'select',
				'options'       => [
					'2'    => esc_html__( '2 Columns', 'diwg-divi-weather-gtm' ),
					'3'    => esc_html__( '3 Columns', 'diwg-divi-weather-gtm' ),
					'4'    => esc_html__( '4 Columns', 'diwg-divi-weather-gtm' ),
					'5'    => esc_html__( '5 Columns', 'diwg-divi-weather-gtm' ),
				],
				'default'       => '3',
				'tab_slug'      => 'advanced',
				'toggle_slug'   => 'layout',
				'show_if'         => [
					'show_weather_forecast' => 'on',
					'layout_forecast'       => 'grid',
				],
			],
			'date_format'    => [
				'label'           => esc_html( 'Forecast Date Format', 'diwg-divi-weather-gtm' ),
				'description'     => esc_html( 'Controls how dates are displayed when showing a forecast. Default is the option set in the Divi Theme options.', 'diwg-divi-weather-gtm' ),
				'option_category' => 'basic_option',
				'type'            => 'text',
				'default'         => et_get_option('divi_date_format'),
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'forecast_design',
				'show_if'         => [
					'show_weather_forecast' => 'on',
				],
			],
			'query_type' => [
				'label'            => esc_html__( 'Fetch weather by', 'diwg-divi-weather-gtm' ),
				'type'             => 'select',
				'option_category'  => 'basic_option',
				'options'          => [
					'name' 	=> esc_html__( 'Location Name', 'diwg-divi-weather-gtm' ),
					'id'	  => esc_html__( 'City ID', 'diwg-divi-weather-gtm' ),
					'zip'	  => esc_html__( 'Zip Code, Country Code', 'diwg-divi-weather-gtm' ),					
				],
				'default'			=> 'name',
				'description' => esc_html__( 'The Open Weather Map API offers a handful of ways to retrieve weather data.', 'diwg-divi-weather-gtm' ),
				'toggle_slug' => 'location',
			],
			'location_name' => [
				'label'           => esc_html__( 'Location Name', 'diwg-divi-weather-gtm' ),
				'type'            => 'text',
				'option_category' => 'basic_option',
				'description'     => esc_html__( 'The name of location you want to show the weather for. Ex: "London,UK" or "Pittsburgh,US". If you\'re having trouble returning the correct data, visit https://openweathermap.org/city and try different variations of the location there. It\'s usually quicker than testing different variations in the plugin.', 'diwg-divi-weather-gtm' ),
				'toggle_slug'     => 'location',
				'show_if' => [
					'query_type' => 'name',
			  ],
			],
			'location_id' => [
				'label'           => esc_html__( 'City ID', 'diwg-divi-weather-gtm' ),
				'type'            => 'text',
				'option_category' => 'basic_option',
				'description'     => esc_html__( 'The Open Weather Map API City ID for the location. Learn more at https://openweathermap.org/current#cityid', 'diwg-divi-weather-gtm' ),
				'toggle_slug'     => 'location',
				'show_if' => [
					'query_type' => 'id',
				],
			],
			'location_zip' => [
				'label'           => esc_html__( 'Zip Code, Country Code', 'diwg-divi-weather-gtm' ),
				'type'            => 'text',
				'option_category' => 'basic_option',
				'description'     => esc_html__( 'Enter the target zip code, followed by a comma and the country code. (ex: 90210,US) Learn more at https://openweathermap.org/current#zip', 'diwg-divi-weather-gtm' ),
				'toggle_slug'     => 'location',
				'show_if' => [
					'query_type' => 'zip',
				],
			],
			'show_weather_current' => [
				'label'           => esc_html__( 'Show Current Weather', 'diwg-divi-weather-gtm' ),
				'type'            => 'yes_no_button',
				'option_category'   => 'basic_option',
				'options'         => [
					'off' => esc_html( 'No', 'diwg-divi-weather-gtm' ),
					'on'  => esc_html( 'Yes', 'diwg-divi-weather-gtm' ),
				],
				'default' => 'on',
				'toggle_slug'	=> 'component',
			],
      'data_component' => [
				'label'           => esc_html__( 'Current Weather Data', 'diwg-divi-weather-gtm' ),
				'description'     => esc_html__( 'This only applies to the current weather. Forecasts only show weather description and average expected temperature.', 'diwg-divi-weather-gtm' ),
				'type'            => 'multiple_checkboxes',
				'option_category' => 'basic_option',
				'options'         => [
					'temp_current'     => esc_html__( 'Current Temperature', 'diwg-divi-weather-gtm' ),
					'temp_min_max'     => esc_html__( 'Min/Max Temperature', 'diwg-divi-weather-gtm' ),
					'wind'             => esc_html__( 'Wind Speed/Direction', 'diwg-divi-weather-gtm' ),
					'humidity'         => esc_html__( 'Humidity', 'diwg-divi-weather-gtm' ),
					'pressure'         => esc_html__( 'Pressure', 'diwg-divi-weather-gtm' ),
				],
				'toggle_slug' => 'component',
				'show_if' => [
					'show_weather_current' => 'on',
				],
			],
			'show_weather_forecast' => [
				'label'           => esc_html__( 'Show Forecasted Weather', 'diwg-divi-weather-gtm' ),
				'type'            => 'yes_no_button',
				'option_category'   => 'basic_option',
				'options'         => [
					'off' => esc_html( 'No', 'diwg-divi-weather-gtm' ),
					'on'  => esc_html( 'Yes', 'diwg-divi-weather-gtm' ),
				],
        'default' => 'off',
				'toggle_slug'	=> 'component',
			],
			'forecast_length'  => [
				'label'            => esc_html__( 'Number of Days to Forecast', 'diwg-divi-weather-gtm' ),
				'option_category'  => 'basic_option',
				'type'             => 'range',
				'range_settings' => [
					'min' => 1,
					'max' => 5,
					'step' => 1,
				],
				'default'       => 3,
				'unitless'      => true,
				'validate_unit' => 'false',
				'toggle_slug'   => 'component',
				'show_if'       => [
					'show_weather_forecast' => 'on'
				],
			],
			'use_description' => [
				'label'           => esc_html__( 'Show weather descriptions?', 'diwg-divi-weather-gtm' ),
				'type'            => 'yes_no_button',
				'option_category'   => 'basic_option',
				'options'         => [
					'off' => esc_html( 'No', 'diwg-divi-weather-gtm' ),
					'on'  => esc_html( 'Yes', 'diwg-divi-weather-gtm' ),
				],
				'default' => 'on',
				'toggle_slug'	=> 'component',
			],
			'lang' => [
				'label'           => esc_html__( 'Language', 'diwg-divi-weather-gtm' ),
				'description'     => esc_html__( 'Used for weather descriptions.', 'diwg-divi-weather-gtm' ),
				'type'            => 'select',
				'option_category'   => 'basic_option',
				'options'           => [
					'ar' 	=> esc_html__( 'Arabic', 'diwg-divi-weather-gtm' ),
					'bg' 	=> esc_html__( 'Bulgarian', 'diwg-divi-weather-gtm' ),
					'ca' 	=> esc_html__( 'Catalan', 'diwg-divi-weather-gtm' ),
					'cz' 	=> esc_html__( 'Czech', 'diwg-divi-weather-gtm' ),
					'de' 	=> esc_html__( 'German', 'diwg-divi-weather-gtm' ),
					'el' 	=> esc_html__( 'Greek', 'diwg-divi-weather-gtm' ),
					'en' 	=> esc_html__( 'English', 'diwg-divi-weather-gtm' ),
					'fa' 	=> esc_html__( 'Persian (Farsi)', 'diwg-divi-weather-gtm' ),
					'fi' 	=> esc_html__( 'Finnish', 'diwg-divi-weather-gtm' ),
					'fr' 	=> esc_html__( 'French', 'diwg-divi-weather-gtm' ),
					'gl' 	=> esc_html__( 'Galician', 'diwg-divi-weather-gtm' ),
					'hr' 	=> esc_html__( 'Croatian', 'diwg-divi-weather-gtm' ),
					'hu' 	=> esc_html__( 'Hungarian', 'diwg-divi-weather-gtm' ),
					'it' 	=> esc_html__( 'Italian', 'diwg-divi-weather-gtm' ),
					'ja' 	=> esc_html__( 'Japanese', 'diwg-divi-weather-gtm' ),
					'kr' 	=> esc_html__( 'Korean', 'diwg-divi-weather-gtm' ),
					'la' 	=> esc_html__( 'Latvian', 'diwg-divi-weather-gtm' ),
					'lt' 	=> esc_html__( 'Lithuanian', 'diwg-divi-weather-gtm' ),
					'mk' 	=> esc_html__( 'Macedonian', 'diwg-divi-weather-gtm' ),
					'nl' 	=> esc_html__( 'Dutch', 'diwg-divi-weather-gtm' ),
					'pl' 	=> esc_html__( 'Polish', 'diwg-divi-weather-gtm' ),
					'pt' 	=> esc_html__( 'Portuguese', 'diwg-divi-weather-gtm' ),
					'ro' 	=> esc_html__( 'Romanian', 'diwg-divi-weather-gtm' ),
					'ru' 	=> esc_html__( 'Russian', 'diwg-divi-weather-gtm' ),
					'se' 	=> esc_html__( 'Swedish', 'diwg-divi-weather-gtm' ),
					'sk' 	=> esc_html__( 'Slovak', 'diwg-divi-weather-gtm' ),
					'sl' 	=> esc_html__( 'Slovenian', 'diwg-divi-weather-gtm' ),
					'es' 	=> esc_html__( 'Spanish', 'diwg-divi-weather-gtm' ),
					'tr' 	=> esc_html__( 'Turkish', 'diwg-divi-weather-gtm' ),
					'ua' 	=> esc_html__( 'Ukrainian', 'diwg-divi-weather-gtm' ),
					'vi' 	=> esc_html__( 'Vietnamese', 'diwg-divi-weather-gtm' ),
					'zh_cn' => esc_html__( 'Chinese Simplified', 'diwg-divi-weather-gtm' ),
					'zh_tw' => esc_html__( 'Chinese Traditional', 'diwg-divi-weather-gtm' ),					
				],
				'default'					=> 'en',
				'toggle_slug'     => 'component',
				'show_if'					=> [
					'use_description'	=> 'on',
				],
			],
			'use_icon' => [
				'label'           => esc_html__( 'Show weather icons?', 'diwg-divi-weather-gtm' ),
				'type'            => 'yes_no_button',
				'option_category' => 'basic_option',
				'options'         => [
					'off' => esc_html( 'No', 'diwg-divi-weather-gtm' ),
					'on'  => esc_html( 'Yes', 'diwg-divi-weather-gtm' ),
				],
				'default' => 'on',
				'description'		=> esc_html__( 'Would you like to show a relevant weather icon? The icon will be selected for you based on the weather data returned by the OpenWeatherMap API.', 'diwg-divi-weather-gtm' ),
				'toggle_slug'		=> 'component',
			],
			'current_icon_color' => [
				'default'  				=> $et_accent_color,
				'label'           => esc_html__( 'Icon Color', 'diwg-divi-weather-gtm' ),
				'type'            => 'color-alpha',
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'current_design',
				'hover'           => 'tabs',
				'show_if'					=> [
					'show_weather_current' => 'on',
					'use_icon'	           => 'on',
				],
			],
			'current_icon_size' => [
				'label'           => esc_html__( 'Icon Font Size', 'diwg-divi-weather-gtm' ),
				'type'            => 'range',
				'range_settings' => [
					'min'  => 21,
					'max'  => 120,
					'step' => 1,
				],
				'default'         => '50px',
				'default_unit'    => 'px',
				'validate_unit'   => 'true',
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'current_design',
				'show_if'					=> [
					'show_weather_current' => 'on',
					'use_icon'	           => 'on',
				],
			],
			'show_label' => [
				'label'           => esc_html__( 'Show Labels', 'diwg-divi-weather-gtm' ),
				'description'     => esc_html__( 'Applies only to additional information like wind, humidity and pressure.', 'diwg-divi-weather-gtm' ),
				'type'            => 'yes_no_button',
				'option_category'   => 'basic_option',
				'options'         => [
					'off' => esc_html( 'No', 'diwg-divi-weather-gtm' ),
					'on'  => esc_html( 'Yes', 'diwg-divi-weather-gtm' ),
				],
				'tab_slug'    => 'advanced',
				'toggle_slug'	=> 'current_design',
				'show_if'     => [
					'show_weather_current' => 'on',
				],
			],
			'forecast_icon_color' => [
				'default'  				=> $et_accent_color,
				'label'           => esc_html__( 'Icon Color', 'diwg-divi-weather-gtm' ),
				'type'            => 'color-alpha',
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'forecast_design',
				'hover'           => 'tabs',
				'show_if'					=> [
					'show_weather_forecast' => 'on',
					'use_icon'	           => 'on',
				],
			],
			'forecast_icon_size' => [
				'label'           => esc_html__( 'Icon Font Size', 'diwg-divi-weather-gtm' ),
				'type'            => 'range',
				'range_settings' => [
					'min'  => 12,
					'max'  => 120,
					'step' => 1,
				],
				'default'         => '21px',
				'default_unit'    => 'px',
				'validate_unit'   => 'true',
				'tab_slug'        => 'advanced',
				'toggle_slug'     => 'forecast_design',
				'show_if'					=> [
					'show_weather_forecast' => 'on',
					'use_icon'	           => 'on',
				],
			],
			'forecast_background' => [
				'label'           => esc_html__( 'Forecast Background', 'diwg-divi-weather-gtm' ),
				'type'            => 'color-alpha',
				'default'         => 'rgba(255,255,255,0)',
				'option_category' => 'layout',
				'tab_slug'        => 'advanced',
				'toggle_slug'	    => 'forecast_design',
				'show_if'         => [
					'show_weather_forecast' => 'on',
				],
			],
			'forecast_icon_color' => [
				'label'           => esc_html__( 'Forecast Icon Color', 'diwg-divi-weather-gtm' ),
				'type'            => 'color-alpha',
				'default'         => 'rgba(0,0,0,0.75)',
				'option_category' => 'layout',
				'tab_slug'        => 'advanced',
				'toggle_slug'	    => 'forecast_design',
				'show_if'         => [
					'show_weather_forecast' => 'on',
				],
			],
			'__weather_data' => [
				'type'                => 'computed',
				'computed_callback'   => [ 'DIWG_Divi_Weather', 'prepare_owm_api_query' ],
				'computed_depends_on' => [
					'show_weather_current',
					'show_weather_forecast',
					'query_type',
					'location_name',
					'location_id',
					'location_zip',
					'lang',
					'date_format'
				],
			],
		];

		return $fields;
	}

	/**
	 * Fetch weather data from the OpenWeatherMap API.
	 * 
	 *  @since 2.0.0
	 */
	static function prepare_owm_api_query( $args = [] )
	{
		$settings   = get_option( OPTION_GROUP_DIWG );
		$appid      = isset( $settings['api_key'] ) ? trim($settings['api_key']) : '';
		$cache_life = isset( $settings['cache_life'] ) && $settings['cache_life'] ? $settings['cache_life'] : 30;
		  
		$params = [];
		$params['app_url']    = "http://api.openweathermap.org/data/2.5/";
		$params['data_model'] = '';
		$params['appid']      = "?appid={$appid}";
		$params['lang']       = "&lang={$args['lang']}";
	
		$location_simple = ''; // Used by transient name.
		switch ( $args['query_type'] ) :
		
			case 'id':
				$params['location'] = ( ! empty($args['location_id'] ) ) ? '&id=' . urlencode( $args['location_id'] ) : false;
				$location_simple = $args['location_id'];
			break;

			case 'zip':
			  $params['location'] = ( ! empty($args['location_zip'] ) ) ? '&zip=' . urlencode( $args['location_zip'] ) : false;
			  $location_simple = $args['location_zip'];
			break;

			default:
			  $params['location'] = ( ! empty($args['location_name'] ) ) ? '&q=' . urlencode( $args['location_name'] ) : false;
				$location_simple = $args['location_name'];
			break;
		endswitch;

		if( ! $params['location'] ) :
			return 'Please enter a valid location';
		else :
			$params['location'] = strtolower( $params['location'] );
		endif;

		// Build transient name.
		$transient_name  = sprintf(
			'divi_weather%1$s%2$s',
			isset( $location_simple ) ? '_' . sanitize_title( $location_simple ) : '',
			isset( $args['lang'] ) ? '_' . $args['lang'] : ''
		);

		// Check for existing transient.
		$transient = get_transient( $transient_name );

		if( $transient ) :
      $weather_data = $transient;
		else :
			
			$weather_data = [];
		  
			$params['data_model'] = 'weather';
			$weather_data['current'] = DIWG_Divi_Weather::fetch_weather_data( $params );
      if( $weather_data['current']->cod != 200 ) return $weather_data['current']->message;
		
		  $params['data_model'] = 'forecast';
		  $weather_data['forecast'] = DIWG_Divi_Weather::fetch_weather_data( $params );
			if( $weather_data['forecast']->cod != 200 ) return $weather_data['forecast']->message; 
			
			if( ! $weather_data ) return 'No weather data to display.';

			// The forecast gives us weather data for every 3 hours. We just want noon on each day.
			if( isset( $weather_data['forecast'] ) && isset( $weather_data['forecast']->list ) ) :
				foreach( $weather_data['forecast']->list as $k => $v ) :
		
					$date = explode(' ',$v->dt_txt);
					if( $date[1] !== '12:00:00') unset($weather_data['forecast']->list[$k]);

				endforeach;
			endif;

			$transient_cache = $cache_life * 60;
	    set_transient( $transient_name, $weather_data, $transient_cache );

		endif;

		if( isset( $weather_data['forecast'] ) && isset( $weather_data['forecast']->list ) ) :
			
			$timezone = DIWG_Divi_Weather::get_wp_timezone();

			$i = 0;
			$weather_list = [];
			foreach( $weather_data['forecast']->list as $item ) :
				
				$day = new DateTime('@' . $item->dt );
			  $day->setTimeZone( $timezone );
				$day = $day->format( $args['date_format'] );

				$item->dt = $day; 

				$weather_list[] = $item;

			endforeach;
			$weather_data['forecast']->list = $weather_list;
			
		endif;

		return $weather_data;
	}

	/**
	 * Fetch WP timezone and account for timezones
	 * based on hour offset rather than a city.
	 * 
	 * @since 1.0.0
	 */
	private static function get_wp_timezone()
	{
    $tzstring = get_option( 'timezone_string' );
    $offset   = get_option( 'gmt_offset' );

    if( empty( $tzstring ) && 0 != $offset && floor( $offset ) == $offset ) :
        $offset_st = $offset > 0 ? "-$offset" : '+'.absint( $offset );
        $tzstring  = 'Etc/GMT'.$offset_st;
		endif;

    // If issue with the timezone selected, set to 'UTC'
    if( empty( $tzstring ) ) $tzstring = 'UTC';

    $timezone = new DateTimeZone( $tzstring );
    return $timezone; 
  }

	/**
	 * Fetch weather data from the OpenWeatherMap API.
	 * 
	 *  @since 2.0.0
	 */
	public static function fetch_weather_data( $params = [] )
	{
		if( ! $params ) return false;

		$api_url = '';
		foreach( $params as $param ) :
			$api_url .= $param;
		endforeach;
		unset( $param );
						
		$response = wp_remote_get( $api_url );

		if ( is_wp_error( $response ) ) :
      return 'There was an error fetching data. Please try again.';
		endif;

		return json_decode( $response['body'] );
	}

	public static function kelvin_to_imperial( $kelvin_temp )
	{
		$fahrenheit = 9/5 * ( $kelvin_temp - 273.15 ) + 32;
		$fahrenheit = round( $fahrenheit );
	  return $fahrenheit ;
	}

	public static function kelvin_to_metric( $kelvin_temp )
  {
		$celsius = $kelvin_temp - 273.15;
		$celsius = round( $celsius );
	  return $celsius ;
	}
	
	public function render( $attrs, $content = null, $render_slug ) {
			    
		$params = [];
		$params['show_weather_current']  = $this->props['show_weather_current'];
		$params['show_weather_forecast'] = $this->props['show_weather_forecast'];
		$params['forecast_length']       = $this->props['forecast_length'];
		$params['query_type']            = $this->props['query_type'];
		$params['location_name']         = $this->props['location_name'];
		$params['location_id']           = $this->props['location_id'];
		$params['location_zip']          = $this->props['location_zip'];
		$params['unit']                  = $this->props['unit'];
		$params['lang']                  = $this->props['lang'];
		$params['date_format']           = $this->props['date_format'];

		$weather_data = DIWG_Divi_Weather::prepare_owm_api_query( $params );
		
		// If it's not an object, it's an error message.
		if( ! is_object( $weather_data ) && ! is_array( $weather_data ) ) : 
			return sprintf(
				'<div class="et_pb_weather__container">
					<div class="et_pb_weather__error">
						%1$s
					</div>
				</div>',
				$weather_data
		    );
		endif; 

		$params['layout_current']        = $this->props['layout_current'];
		$params['layout_forecast']       = $this->props['layout_forecast'];
		$params['grid_columns']          = $this->props['grid_columns'];
		$params['date_format']           = $this->props['date_format'];
		$params['use_description']       = $this->props['use_description'];
		$params['use_icon']              = $this->props['use_icon'];
		$params['current_icon_color']    = $this->props['current_icon_color'];
		$params['current_icon_size']     = $this->props['current_icon_size'];
		$params['show_label']            = $this->props['show_label'];
		$params['forecast_icon_color']   = $this->props['forecast_icon_color'];
		$params['forecast_icon_size']    = $this->props['forecast_icon_size'];
		$params['forecast_background']   = $this->props['forecast_background'];
		$params['forecast_icon_color']   = $this->props['forecast_icon_color'];
		$params['data_component']        = explode( '|', $this->props['data_component'] );
		
		if( 'on' === $params['show_weather_current'] ) :
		  $params['show_temp']      = $params['data_component'][0];
		  $params['show_min_max']   = $params['data_component'][1];
		  $params['show_wind']      = $params['data_component'][2];
		  $params['show_humidity']  = $params['data_component'][3];
			$params['show_pressure']  = $params['data_component'][4];
		endif;

		$params['temp_unit'] = 'imperial' === $params['unit']  ? 'F' : 'C';
		$params['wind_unit'] = 'imperial' === $params['unit']  ? 'm/h' : 'm/s';

		$temp_conversion = 'imperial' === $params['unit'] ? 'DIWG_Divi_Weather::kelvin_to_imperial' : 'DIWG_Divi_Weather::kelvin_to_metric';
		
		ET_Builder_Element::set_style( $render_slug, array(
			'selector'    => '%%order_class%%',
			'declaration' => sprintf(
			    'background-size:%1$s;
			    background-position:%2$s;
			    background-repeat:%3$s;',
			    $this->props['background_size'],
			    $this->props['background_position'],
			    $this->props['background_repeat']
			)
		));

 		// Forecast background.
		ET_Builder_Element::set_style( $render_slug, array(
			'selector'    => '%%order_class%% .et_pb_weather__forecast',
			'declaration' => sprintf('background-color:%1$s;',$params['forecast_background'])
		));

		if ( 'on' === $params['use_icon'] ) :

			// Current icon color.
			ET_Builder_Element::set_style( $render_slug, array(
				'selector'    => '%%order_class%% .et_pb_weather__current .et_pb_weather__icon',
				'declaration' => sprintf('color:%1$s;',$params['current_icon_color'])
			));

			// Current icon size.
			ET_Builder_Element::set_style( $render_slug, array(
				'selector'    => '%%order_class%% .et_pb_weather__current .et_pb_weather__icon',
				'declaration' => sprintf('font-size:%1$s;',$params['current_icon_size'])
			));

			// Forecast icon color.
			ET_Builder_Element::set_style( $render_slug, array(
				'selector'    => '%%order_class%% .et_pb_weather__forecast .et_pb_weather__icon',
				'declaration' => sprintf('color:%1$s;',$params['forecast_icon_color'])
			));

			// Current icon size.
			ET_Builder_Element::set_style( $render_slug, array(
				'selector'    => '%%order_class%% .et_pb_weather__forecast .et_pb_weather__icon',
				'declaration' => sprintf('font-size:%1$s;',$params['forecast_icon_size'])
			));

		endif;

		// Set our weather data.
		$weather_current  = isset( $weather_data['current'] ) ? $weather_data['current'] : [];
		$weather_forecast = isset( $weather_data['forecast'] ) ? $weather_data['forecast']->list : [];

		$output_current = '';
		if( 'on' === $params['show_weather_current'] ) :
		  $current_icon     = ( isset($params['use_icon']) && 'on' === $params['use_icon']  && $weather_current->weather[0]->id ) ? '<span class="et_pb_weather__icon wi wi-owm-' . esc_attr( $weather_current->weather[0]->id ) . '"></span>' : '';
			$current_desc     = ( isset($params['use_description']) && 'on' === $params['use_description'] && $weather_current->weather[0]->description ) ? '<span class="et_pb_weather__current_description">' . $weather_current->weather[0]->description  . '</span>' : '';
			
			$current_temp     = ( isset($params['show_temp'] ) && 'on' === $params['show_temp'] && $weather_current->main->temp ) ? '<span class="et_pb_weather__current_temp">' . $temp_conversion( $weather_current->main->temp ) . '&deg; ' . $params['temp_unit'] . '</span>' : '';
		  $current_min_max  = (  isset( $params['show_min_max'] ) && 'on' === $params['show_min_max'] && $weather_current->main->temp_min && $weather_current->main->temp_max ) ? '<span class="et_pb_weather__current_min_max">' . $temp_conversion( $weather_current->main->temp_min ) . '&deg; ' . $params['temp_unit'] . ' | ' . $temp_conversion( $weather_current->main->temp_max ) . '&deg; ' . $params['temp_unit'] . '</span>' : '';
			
			$current_humidity = ( isset( $params['show_humidity'] ) && 'on' === $params['show_humidity']  && $weather_current->main->humidity ) ? '<span class="et_pb_weather__current_humidity" data-label="' . esc_attr( __('Humidity', 'diwg-divi-weather-gtm') ) . '">' . $weather_current->main->humidity . ' <span class="et_pb_weather__unit">%</span></span>' : '';
		  $current_pressure = ( isset($params['show_pressure']) && 'on' === $params['show_pressure']  && $weather_current->main->pressure ) ? '<span class="et_pb_weather__current_pressure" data-label="' . esc_attr( __('Pressure', 'diwg-divi-weather-gtm') ) . '">' . $weather_current->main->pressure . ' <span class="et_pb_weather__unit">hPa</span></span>' : '';

		  $current_group_description = ( $current_icon || $current_desc ) ? sprintf(
			  '<span class="et_pb_weather__current_icon_description">
				  %1$s
				  %2$s
			  </span>',
			  $current_icon,
			  $current_desc
		  ) : '';
		
		  $current_group_temp = ( $current_temp || $current_min_max ) ? sprintf(
			  '<span class="et_pb_weather__current_temps">
				  %1$s
				  %2$s
			  </span>',
			  $current_temp,
			  $current_min_max
		  ) : '';

		  $current_wind_icon = ( isset( $params['show_wind'] ) && 'on' === $params['show_wind'] && $weather_current->wind->deg ) ?
		  sprintf(
			  '<span class="wi wi-wind towards-%1$s-deg"></span>',
			  esc_attr( $weather_current->wind->deg )
		  ) : '';

		  $current_wind = ( isset( $params['show_wind'] ) && 'on' === $params['show_wind'] && $weather_current->wind->speed ) ?
		  sprintf(
			  '<span class="et_pb_weather__current_wind" data-label="%4$s">
			    %1$s
				  <span class="et_pb_weather__current_wind_speed">
				    %2$s 
					  <span class="et_pb_weather__unit">%3$s</span>
				  </span>
			  </span>',
			  $current_wind_icon,
			  'imperial' === $this->props['unit'] ? number_format( (float)($weather_current->wind->speed * 2.237),2, '.', '' ) : $weather_current->wind->speed,
			  $params['wind_unit'],
			  esc_attr( __('Wind', 'diwg-divi-weather-gtm') )
		  ) : '';

		  $current_group_additional = ( $current_wind || $current_humidity || $current_pressure ) ? sprintf(
		  '<span class="et_pb_weather__current_additional">
			  %1$s
			  %2$s
			  %3$s
		  </span>',
		  $current_wind,
		  $current_humidity,
		  $current_pressure
		  ) : '';

		  $output_current = sprintf(
			  '<div class="et_pb_weather__current">
				  %1$s
				  %2$s
				  %3$s
			  </div>',
			  $current_group_description,
			  $current_group_temp,
			  $current_group_additional
			);
		endif;

		$forecast_items  = '';
		$output_forecast = '';
		$weather_forecast = array_slice( $weather_forecast, 0, $this->props['forecast_length'] );
		if( 'on' === $params['show_weather_forecast'] && count( $weather_forecast ) > 1 ) :
			
			foreach( $weather_forecast as $date ) :
			    
			  $forecast_desc_el = 'on' === $params['use_description'] ? '<span class="et_pb_weather__forecast_desc">' . $date->weather[0]->description . '</span>' : '';
	
				$forecast_items .= sprintf(
					'<li class="et_pb_weather__forecast_item">
					  <span class="et_pb_weather__forecast_text">
							<span class="et_pb_weather__forecast_date">%1$s</span>
							%2$s
						</span>
						<span class="et_pb_weather__forecast_display">
							%3$s
							<span class="et_pb_weather__forecast_temp">%4$s</span>
						</span>
					</li>',
					$date->dt,
					$forecast_desc_el,
					'on' === $params['use_icon'] ? sprintf(
						'<span class="et_pb_weather__icon wi wi-owm-%1$s"></span>',
						$date->weather[0]->id
					) : '',
					$temp_conversion( $date->main->temp ) . '&deg; ' . $params['temp_unit']
				);
			endforeach;
		endif;

		$output_forecast = '';
		if( 'on' === $params['show_weather_forecast'] ) :
		  $output_forecast = $weather_forecast ? sprintf(
			  '<ul class="et_pb_weather__forecast">
			    %1$s
			  </ul>',
			  $forecast_items
			) : '';
		endif;
	
		$output = sprintf(
			'<div class="et_pb_weather__container %1$s %2$s %3$s %4$s">
				%5$s
				%6$s
			</div>',
			'on' === $params['show_label'] ? 'et_pb_weather__current--show_labels' : '',
			'et_pb_weather__current--' . $params['layout_current'],
			'on' === $params['show_weather_forecast'] ? 'et_pb_weather__forecast--' . $params['layout_forecast'] : '',
			isset( $params['layout_forecast'] ) && 'grid' === $params['layout_forecast'] ? 'et_pb_weather__forecast--grid--' . $params['grid_columns'] : '',
			$output_current,
			$output_forecast
		);
		
		return $output;
	}
}

new DIWG_Divi_Weather;