<?php
$tooltip = array();
$license = trim( get_option( KEY_PREFIX_DIWG . 'license_key' ) );
$status  = trim( get_option( KEY_PREFIX_DIWG . 'license_status' ) );

$status_notify = 
sprintf(
 '<span class="wpcc_plugin_license_status %1$s">%2$s</span>',
 ( isset($status) && 'valid' === $status ) ? 'wpcc_plugin_license_status--active' : '',
 ( isset($status) && 'valid' === $status ) ? __('Active') : __('Inactive')
);

?>

<div id="plugin_settings_wpcc" class="wrap">

  <div class="row">
    <div class="col s12">
      <h2><?php echo esc_html( get_admin_page_title() ); ?></h2>
    </div>
  </div>

  <div class="row">

	  <div class="col m12 l8">

      <section class="settings_panel">
        <header class="settings_panel__heading">
          <h3 class="settings_panel__icon settings_panel__icon--settings">Settings</h3>
        </header>
        <div class="settings_panel__body settings_panel__body"> 
        <form method="post" action="options.php">
          <?php
					  settings_fields( PLUGIN_SLUG_DIWG );    
            do_settings_sections( PLUGIN_SLUG_DIWG );
					  submit_button();
          ?>
          </form>
 
        </div>
      </section>

    </div><!-- /.settings_panel -->

    <div class="col m12 l4">

      <aside class="settings_panel">
        <header class="settings_panel__heading">
          <h3 class="settings_panel__icon settings_panel__icon--clear"><?php _e('Clear Cache'); ?></h3>
        </header>
        <div class="settings_panel__body">
          <form method="post" action="options.php">

            <div class="settings_panel__group">
              <?php wp_nonce_field( 'clear_cache_nonce', KEY_PREFIX_DIWG . 'nonce' ); ?>
              <button name="<?php echo KEY_PREFIX_DIWG; ?>clear_cached_weather" class="button-secondary settings_panel__button settings_panel__button--secondary">Clear Cached Weather Data</button>
					    <p class="settings_panel__description"><?php _e('This will clear all cached weather data and force the system to fetch new data the next time a page is loaded that contains the weather module.'); ?></p>
            </div>

          </form>
        </div>
      </aside>

      <aside class="settings_panel">
        <header class="settings_panel__heading">
          <h3 class="settings_panel__icon settings_panel__icon--license"><?php echo __('License') . ': ' . $status_notify ?></h3>
        </header>
        <div class="settings_panel__body">
          <form method="post" action="options.php">

            <div class="settings_panel__group">
              <label for="license_key"><?php _e('License Key'); ?></label>
              <input id="<?php echo KEY_PREFIX_DIWG; ?>license_key" name="<?php echo KEY_PREFIX_DIWG; ?>license_key" type="text" class="settings_panel__input" style="display:block;width:100%" value="<?php esc_attr_e( $license ); ?>" />
					    <p class="settings_panel__description" for="<?php echo KEY_PREFIX_DIWG; ?>license_key"><?php _e('Enter your license key to enable plugin updates.'); ?></p>
            </div>

            <div class="settings_panel__group">
            <?php
              wp_nonce_field( 'license_action_nonce', KEY_PREFIX_DIWG . 'nonce' );
              if( isset($status) && $status === 'valid' ) : ?>
                <button type="submit" class="button-secondary settings_panel__button settings_panel__button--secondary" name="<?php echo KEY_PREFIX_DIWG; ?>license_deactivate"><?php _e('Deactivate License'); ?></button>
              <?php
              else : ?>
                <button type="submit" class="button-secondary settings_panel__button settings_panel__button--secondary" name="<?php echo KEY_PREFIX_DIWG; ?>license_activate"><?php _e('Activate License'); ?></button>
              <?php
              endif;
            ?>
            <button type="submit" class="button-secondary settings_panel__button settings_panel__button--text" name="<?php echo KEY_PREFIX_DIWG; ?>license_clear"><?php _e('Remove license data on this site'); ?></button>
            </div>

          </form>
        </div>
      </aside>

    </div>
  </div><!-- /.row -->

  <div class="row">
    <div class="col s12">
      <section class="plugin_settings_footer">
        <p>Built with <span class="dashicons dashicons-heart"></span> by <a href="https://wpcreatorsclub.com" target="_blank">WP Creator's Club</a>. We're all in this together.</p>
      </section>
    </div>
  </div>


</div><!-- /.wrap -->