<?php
$tooltip = array();
$license = trim( get_option( 'wp_creators_club_license_key' ) );
$status  = trim( get_option( 'wp_creators_club_license_status' ) );

$status_notify = 
sprintf(
 '<span class="wpcc_plugin_license_status %1$s">%2$s</span>',
 ( isset($status) && 'valid' === $status ) ? 'wpcc_plugin_license_status--active' : '',
 ( isset($status) && 'valid' === $status ) ? __('Active') : __('Inactive')
);

?>

<div id="plugin_settings_wpcc" class="wrap">

  <div class="row">
    <div class="col s12">
      <h2><?php echo esc_html( get_admin_page_title() ); ?></h2>
    </div>
  </div>

  <div class="row">

	  <div class="col m12 l6">

      <section class="settings_panel">
        <header class="settings_panel__heading">
          <h3 class="settings_panel__icon settings_panel__icon--user"><?php echo __('Product Updates') . ': ' . $status_notify ?></h3>
        </header>
        <div class="settings_panel__body settings_panel__body"> 
          <form method="post" action="options.php">

            <p>Enter your license key in the field below to 
              activate "one-click updates" of Creator's Club products on this site.
            </p>

            <div class="settings_panel__group">
              <label for="license_key"><?php _e('License Key'); ?></label>
              <input id="wp_creators_club_license_key" name="wp_creators_club_license_key" type="text" class="settings_panel__input" style="display:block;width:100%" value="<?php esc_attr_e( $license ); ?>" />
              <p class="settings_panel__description" for="wp_creators_club_license_key"><?php _e('Enter your license key to enable product updates.'); ?></p>
            </div>

            <div class="settings_panel__group">
              <?php
              wp_nonce_field( 'license_action_nonce', 'creators_club_nonce' );
              if( isset($status) && $status === 'valid' ) : ?>
                <button type="submit" class="button-secondary settings_panel__button settings_panel__button--secondary" name="creators_club_license_deactivate"><?php _e('Deactivate License'); ?></button>
                <?php
              else : ?>
                <button type="submit" class="button-secondary settings_panel__button settings_panel__button--secondary" name="creators_club_license_activate"><?php _e('Activate License'); ?></button>
              <?php
              endif; ?>
             <button type="submit" class="button-secondary settings_panel__button settings_panel__button--text" name="creators_club_license_clear"><?php _e('Remove license data on this site'); ?></button>
            </div>
          </form>
        </div>
      </section>

    </div><!-- /.settings_panel -->

    <div class="col m12 l6">

      <aside class="settings_panel">
        <header class="settings_panel__heading">
          <h3 class="settings_panel__icon settings_panel__icon--logo">Not a Member?</h3>
        </header>
        <div class="settings_panel__body">
          <p>
            This plugin was built by the developers at WP Creator's Club - an 
            online community of members just like you who design sites in Wordpress 
            (and Divi!) and are looking for a better way.
          </p>
          <p>
            All WP Creator's Club members receive unlimited access (unlimited updates and use on unlimited sites) for:
          </p>
          <ul class="member_perks">
            <li>Our full catalog of plugins, which we will continue to add to</li>
            <li>All of our child themes (coming soon!)</li>
            <li>Plugin/Child Theme development request</li>
            <li>Unlimited priority support</li>
          </ul>

          <p style="margin-bottom:30px">
            Interested in becoming a member and gaining access to everything 
            a WP Creator's Club membership offers? 
          </p>
          <a href="https://wpcreatorsclub.com" class="settings_panel__button" target="_blank">Learn More</a>
        </div>
      </aside>

    </div>
  </div><!-- /.row -->

  <div class="row">
    <div class="col s12">
      <section class="plugin_settings_footer">
        <p>Built with <span class="dashicons dashicons-heart"></span> by <a href="https://wpcreatorsclub.com" target="_blank">WP Creator's Club</a>. We're all in this together.</p>
      </section>
    </div>
  </div>


</div><!-- /.wrap -->